#ifndef UTIL_H
#define UTIL_H

#define ERROR_INVOCATION 1
#define ERROR_FILES 2
#define ERROR_INTERNAL 3

void init_table(void **table, int *cur_size, int new_size, int entry_size);
void expand_table(void **table, int *cur_size, int new_size, int entry_size);

char parse_escape(const char **str);
int parse_char_constant(const char *str);
char *parse_string(const char *str);

void numeric_bytes(char *data, int size);

void error_internal_memory(void);
void error_internal_param(void);
void error_undefined_identifier(const char *id);
void warn_escape_sequence(void);
void warn_range(int v);
void warn_dup_label(const char *identifier);
void warn_undefined_reference(const char *identifier);
void warn_multiple_definition(const char *identifier);


#endif

